EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_POPUP_EVENT_BACKWALL_CLICKED =
   EFL_EVENT_DESCRIPTION("backwall,clicked");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_POPUP_EVENT_TIMEOUT =
   EFL_EVENT_DESCRIPTION("timeout");

void _efl_ui_popup_align_set(Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Ui_Popup_Align type);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_popup_align_set, EFL_FUNC_CALL(type), Efl_Ui_Popup_Align type);

Efl_Ui_Popup_Align _efl_ui_popup_align_get(const Eo *obj, Efl_Ui_Popup_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_popup_align_get, Efl_Ui_Popup_Align, 0);

void _efl_ui_popup_closing_timeout_set(Eo *obj, Efl_Ui_Popup_Data *pd, double time);


static Eina_Error
__eolian_efl_ui_popup_closing_timeout_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_popup_closing_timeout_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_popup_closing_timeout_set, EFL_FUNC_CALL(time), double time);

double _efl_ui_popup_closing_timeout_get(const Eo *obj, Efl_Ui_Popup_Data *pd);


static Eina_Value
__eolian_efl_ui_popup_closing_timeout_get_reflect(const Eo *obj)
{
   double val = efl_ui_popup_closing_timeout_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_popup_closing_timeout_get, double, 0);

void _efl_ui_popup_anchor_set(Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Canvas_Object *anchor);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_popup_anchor_set, EFL_FUNC_CALL(anchor), Efl_Canvas_Object *anchor);

Efl_Canvas_Object *_efl_ui_popup_anchor_get(const Eo *obj, Efl_Ui_Popup_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_popup_anchor_get, Efl_Canvas_Object *, NULL);

void _efl_ui_popup_align_priority_set(Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Ui_Popup_Align first, Efl_Ui_Popup_Align second, Efl_Ui_Popup_Align third, Efl_Ui_Popup_Align fourth, Efl_Ui_Popup_Align fifth);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_popup_align_priority_set, EFL_FUNC_CALL(first, second, third, fourth, fifth), Efl_Ui_Popup_Align first, Efl_Ui_Popup_Align second, Efl_Ui_Popup_Align third, Efl_Ui_Popup_Align fourth, Efl_Ui_Popup_Align fifth);

void _efl_ui_popup_align_priority_get(const Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Ui_Popup_Align *first, Efl_Ui_Popup_Align *second, Efl_Ui_Popup_Align *third, Efl_Ui_Popup_Align *fourth, Efl_Ui_Popup_Align *fifth);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_popup_align_priority_get, EFL_FUNC_CALL(first, second, third, fourth, fifth), Efl_Ui_Popup_Align *first, Efl_Ui_Popup_Align *second, Efl_Ui_Popup_Align *third, Efl_Ui_Popup_Align *fourth, Efl_Ui_Popup_Align *fifth);

Efl_Object *_efl_ui_popup_efl_object_constructor(Eo *obj, Efl_Ui_Popup_Data *pd);


void _efl_ui_popup_efl_object_destructor(Eo *obj, Efl_Ui_Popup_Data *pd);


void _efl_ui_popup_efl_object_invalidate(Eo *obj, Efl_Ui_Popup_Data *pd);


void _efl_ui_popup_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Popup_Data *pd);


void _efl_ui_popup_efl_gfx_entity_position_set(Eo *obj, Efl_Ui_Popup_Data *pd, Eina_Position2D pos);


void _efl_ui_popup_efl_gfx_entity_size_set(Eo *obj, Efl_Ui_Popup_Data *pd, Eina_Size2D size);


void _efl_ui_popup_efl_gfx_entity_visible_set(Eo *obj, Efl_Ui_Popup_Data *pd, Eina_Bool v);


void _efl_ui_popup_efl_ui_widget_widget_parent_set(Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Ui_Widget *parent);


Eina_Bool _efl_ui_popup_efl_content_content_set(Eo *obj, Efl_Ui_Popup_Data *pd, Efl_Gfx_Entity *content);


Efl_Gfx_Entity *_efl_ui_popup_efl_content_content_get(const Eo *obj, Efl_Ui_Popup_Data *pd);


Efl_Gfx_Entity *_efl_ui_popup_efl_content_content_unset(Eo *obj, Efl_Ui_Popup_Data *pd);


Efl_Object *_efl_ui_popup_efl_part_part_get(const Eo *obj, Efl_Ui_Popup_Data *pd, const char *name);


static Eina_Bool
_efl_ui_popup_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_POPUP_EXTRA_OPS
#define EFL_UI_POPUP_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_popup_align_set, _efl_ui_popup_align_set),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_align_get, _efl_ui_popup_align_get),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_closing_timeout_set, _efl_ui_popup_closing_timeout_set),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_closing_timeout_get, _efl_ui_popup_closing_timeout_get),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_anchor_set, _efl_ui_popup_anchor_set),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_anchor_get, _efl_ui_popup_anchor_get),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_align_priority_set, _efl_ui_popup_align_priority_set),
      EFL_OBJECT_OP_FUNC(efl_ui_popup_align_priority_get, _efl_ui_popup_align_priority_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_popup_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_popup_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_popup_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_popup_efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, _efl_ui_popup_efl_gfx_entity_position_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, _efl_ui_popup_efl_gfx_entity_size_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, _efl_ui_popup_efl_gfx_entity_visible_set),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_parent_set, _efl_ui_popup_efl_ui_widget_widget_parent_set),
      EFL_OBJECT_OP_FUNC(efl_content_set, _efl_ui_popup_efl_content_content_set),
      EFL_OBJECT_OP_FUNC(efl_content_get, _efl_ui_popup_efl_content_content_get),
      EFL_OBJECT_OP_FUNC(efl_content_unset, _efl_ui_popup_efl_content_content_unset),
      EFL_OBJECT_OP_FUNC(efl_part_get, _efl_ui_popup_efl_part_part_get),
      EFL_UI_POPUP_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"closing_timeout", __eolian_efl_ui_popup_closing_timeout_set_reflect, __eolian_efl_ui_popup_closing_timeout_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_popup_class_desc = {
   EO_VERSION,
   "Efl.Ui.Popup",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Popup_Data),
   _efl_ui_popup_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_popup_class_get, &_efl_ui_popup_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_CONTENT_INTERFACE, EFL_UI_FOCUS_LAYER_MIXIN, EFL_UI_WIDGET_SCROLLABLE_CONTENT_MIXIN, NULL);
